"Object Domain UML Module"

"""
 Copyright (c) 1998 by Object Domain Systems Inc.
 All rights reserved.

 This script is provided as part of ObjectDomain. Derivations and
 extensions to the source code are permitted provided (a) the derivative
 works are used in conjunction with ObjectDomain and (b) this copyright
 notice is retained in its entirety. Any use of this script, in part or full,
 for the benefit of competitive products is strictly prohibited.
"""

import string
from java.lang import Class
from objectdomain.uml import command
from objectdomain.uml.core import IElement, IElementCollection
from objectdomain import domain
from objectdomain.domain import Domain
from objectdomain.uml.mechanisms import UmlWorld
from objectdomain.utility import OdsUtil
from odApp import OdApp
import odApp

class OdUml:
  ELEMENT_REF_CHAR = "."

  def createElement(self, elementTypeName, owner=None, name=None):
    #print 'createElement'
    cmd = None
    cmdStr = 'cmd = domain.commands.Create' + elementTypeName + 'Cmd()'
    try:
      exec(cmdStr)
      #print cmdStr
    except:
      cmdStr = 'cmd = command.Create' + elementTypeName + 'Cmd()'
      try:
        exec(cmdStr)
        #print cmdStr
      except:
        try:
          cmdStr = 'cmd = command.CreateUml' + elementTypeName + 'Cmd()'
          exec(cmdStr)
          #print cmdStr
        except:
          print 'Creation error - unknown element type: ' + elementTypeName
          return None
    #PHIL return the just created element following the spec in the help file
    res=OdUml.doCmd(cmd, owner, name)
    #print 'doCmd:',cmd,owner,name
    return res


  # *** helper class methods ***

  def getCreatedElementOwner(owner):
    firstSelected = OdApp.instance().getFirstSelectedElement()
    if owner == None:
      return firstSelected
    else:
      owner = OdUml.getElementOrCollectionFrom(owner)
      if isinstance(owner, IElementCollection):
        firstSelected
      else:
        return owner

  def doCmd(cmd, owner, name):
    # if owner is not a "." QualifiedName, assume the user
    # intended to call createXXX(None, 'MyName') and map owner to name
    if OdUml.isDotQualifiedName(owner):
      name = owner
      owner = None

    cmd.initialize(None, OdApp.instance().getSelection())
    owner = OdUml.getCreatedElementOwner(owner)
    cmd.setPotentialOwner(owner)
    if name != None:
      cmd.setObjectName(name)
    if cmd.handleCanDo():
      Domain.instance().addAndDo(cmd)
    else:
      OdsUtil.beep() # todo

    #PHIL      return the element just created following the spec in the help file
    return cmd.getCreatedElement()
  

  def getElementOrCollectionFrom(o):
    if isinstance(o, IElement):
      return o
    elif isinstance(o, IElementCollection):
      return o
    else:
      return odApp.nameToElement(o)

  def isDotQualifiedName(o):
    if isinstance(o, type('')):
      return string.find(o, OdUml.ELEMENT_REF_CHAR) != 0
    else:
      return 0




