"""
 Copyright (c) 2001 by Object Domain Systems Inc.
 All rights reserved.

 This script is provided as part of ObjectDomain. Derivations and
 extensions to the source code are permitted provided (a) the derivative
 works are used in conjunction with ObjectDomain and (b) this copyright
 notice is retained in its entirety. Any use of this script, in part or full,
 for the benefit of competitive products is strictly prohibited.
"""

import sys, os

sys.add_package('objectdomain')
sys.add_package('objectdomain.swing')
sys.add_package('objectdomain.domain')
sys.add_package('objectdomain.domain.persistence')
sys.add_package('objectdomain.domain.panel')
sys.add_package('objectdomain.domain.search')
sys.add_package('objectdomain.domain.browser')
sys.add_package('objectdomain.domain.tree')
sys.add_package('objectdomain.domain.swing')
sys.add_package('objectdomain.domain.extension')
sys.add_package('objectdomain.domain.scripting')
sys.add_package('objectdomain.utility')
sys.add_package('objectdomain.domain.commands')
sys.add_package('objectdomain.domain.diagram.command')
sys.add_package('objectdomain.uml.command')
sys.add_package('objectdomain.uml')
sys.add_package('objectdomain.uml.utility')
sys.add_package('objectdomain.uml.core')
sys.add_package('objectdomain.uml.xmi')
sys.add_package('objectdomain.uml.mechanisms')
sys.add_package('objectdomain.uml.behavioral')
sys.add_package('objectdomain.uml.behavioral.common')
sys.add_package('objectdomain.uml.behavioral.statemachine')
sys.add_package('objectdomain.uml.behavioral.usecase')
sys.add_package('objectdomain.uml.behavioral.collaboration')
sys.add_package('objectdomain.uml.view')
sys.add_package('objectdomain.uml.editor')
sys.add_package('objectdomain.uml.view.styles')
sys.add_package('com.objectspace.jgl')
sys.add_package('com.objectspace.jgl.algorithms')
sys.add_package('com.objectspace.jgl.predicates')
sys.add_package('objectdomain.versioncontrol')
sys.add_package('objectdomain.io')
sys.add_package('objectdomain.uml.tools.merge')

# add scripts dir to search path
def addSysPath(newPath):
  if newPath not in sys.path:
    sys.path.append(newPath)

from objectdomain.utility import OdsUtil
from objectdomain.swing import OdsSwingUtil
from java.lang import System

appDataDir = OdsSwingUtil.getAppDataDir();
addSysPath(appDataDir + os.sep + "python" + os.sep + "scripts")
addSysPath(appDataDir + os.sep + "python" + os.sep + "Lib"  + os.sep +  "HTMLgen")

installRoot = OdsUtil.getInstallRoot();
if installRoot != None and installRoot != "":
  addSysPath(installRoot + os.sep + "python" + os.sep + "scripts")
  addSysPath(installRoot + os.sep + "python" + os.sep + "Lib"  + os.sep +  "HTMLgen")

import odApp
import odUml

# import common stuff
from odApp import OdApp
from odUml import OdUml
from odDiagram import OdDiagram

import objectdomain
import objectdomain.domain
import objectdomain.domain.extension
import objectdomain.utility
import objectdomain.domain.scripting
import objectdomain.domain.commands
import objectdomain.domain.diagram.command
import objectdomain.uml.core
import objectdomain.uml.mechanisms
import objectdomain.uml.behavioral
import objectdomain.uml.behavioral.common
import objectdomain.uml.behavioral.statemachine
import objectdomain.uml.behavioral.usecase
import objectdomain.uml.behavioral.collaboration
import objectdomain.uml.view
import objectdomain.uml.utility
import objectdomain.uml.view.styles
import objectdomain.versioncontrol

import odUserSetup

od = OdApp()

execfile(odUserSetup.__file__)













